/**********************************************************\
* [PON] LCD Pong game                              Sandman *
* v1.01                                                    *
\**********************************************************/

/* LCD support */
	include "LCD.fh";

GLOBAL
	struct LCDC;
		string name;			// Name given
		int Width;				// Width of the LCD
		int Height;				// Height of the LCD
		int Depth;				// Depth of the LCD
		int Buttons;			// Number of buttons of the LCD
		struct Device[0];
			int but;			// Button integer for a maximum of 32 buttons (G15 has 4)
			int map;        	// Map
			byte pointer pmap;	// Pointer to the map, returned by map_buffer()
		end
	end

	struct Paddle[1];
		x;y;					// Coors
		w;h;					// Size
		topspeed;
		score;
		speedy;
	end

	struct Ball[0];
		alive;
		x;y;
		w;h;
		speedx;
		speedy;
		speed;
		angle;
		noclip[1];
		tx;ty;
		float speedinc;
	end
	struct BallS[9];
		x;y;
		w;h;
	end

	float tf;
	dif;
	downside;

	fenixdisplay = 0;

PRIVATE
	i;

BEGIN

	set_mode(110,10,8);
	write(0,1,1,0,"LCD PONG");

/* LCD */
	LCDC.name = "LCD Pong";
	LCD_INIT(LCDC.name);
	LCD_OPEN(0,&LCDC.Device.but);

	LCDC.Device.map = new_map(160,43,8);
	LCDC.Device.pmap = map_buffer(0,LCDC.Device.map);
	set_center(0,LCDC.Device.map,0,0);

/* Paddles */
	Paddle[0].x = 000;
	Paddle[0].y = 300;
	Paddle[0].w = 2*100;
	Paddle[0].h = 9*100;
	Paddle[0].topspeed = 200;
	Paddle[0].score = 0;

	Paddle[1].x = 15800;
	Paddle[1].y =  300;
	Paddle[1].w = 2*100;
	Paddle[1].h = 9*100;
	Paddle[1].topspeed = 200;
	Paddle[1].score = 0;

/* Ball */
	Ball[0].x = 8000-Ball[0].w/2;
	Ball[0].y = 2100-Ball[0].h/2;
	Ball[0].w = 3*100;
	Ball[0].h = 3*100;
	Ball[0].speedinc = 1.02;
    Ball[0].noclip = 1;
	Ball[0].alive = 0;

/* Drawing loop */
	draw_lcd();


	WHILE(!key(_esc))

    	if(key(_F1))
    		if(fenixdisplay)
    			set_mode(110,10,8);
				fenixdisplay = 0;
    		else
    			set_mode(320,200,8);
				drawing_map(0,0);
				drawing_color(rgb(255,255,255));
				draw_rect(9,9,171,54);
				fenixdisplay = 1;
			end
			while(key(_F1)) frame; end
    	end
	/* Ball left or right off screen */
		if(Ball[0].x+Ball[0].w<0) // ball behind left paddle
			Ball[0].alive = 0;
			Ball[0].x = 8000-Ball[0].w/2;
			Ball[0].y = 2100-Ball[0].h/2;
			Ball[0].speed = 0;
			Paddle[1].score++;
		end
		if(Ball[0].x>16000) // ball behind right paddle
			Ball[0].alive = 0;
			Ball[0].x = 8000-Ball[0].w/2;
			Ball[0].y = 2100-Ball[0].h/2;
			Ball[0].speed = 0;
			Paddle[0].score++;
		end

		/* Movement stuff */
		Ball[0].speedx = cos(Ball[0].angle)*Ball[0].speed;
		Ball[0].speedy = -sin(Ball[0].angle)*Ball[0].speed;

	    Ball[0].tx = Ball[0].x+Ball[0].speedx;
	    Ball[0].ty = Ball[0].y+Ball[0].speedy;

		for(i=10; i>0; i--) // increased accuracy
		/* Ball and paddle collision */
			for(z=0; z<=1; z++)
				if(Ball_col(z))// ball collides with a paddle...
					if(!Ball[0].noclip[z]) // ...and he did not do that recently
						Ball[0].angle = (180000-Ball[0].angle);    //360!
						Ball[0].speed = Ball[0].speed*Ball[0].speedinc;
						Ball[0].noclip[z] = 1;
						dif = (Paddle[z].y+Paddle[z].h/2)-(Ball[0].y+Ball[0].h/2);
						downside = dif<0;
						tf= ( ( abs(dif) )*2 / Paddle[z].h ); //abs() is needed for ->float conversion it seems :/
						if(dif<0)
							tf=-tf;
						end
						if(Ball[0].angle>90000&&Ball[0].angle<270000) // Paddle 1
                        	Ball[0].angle+=10000*Paddle[z].speedy/Paddle[z].topspeed-20000*tf;
						else // Paddle 0
                        	Ball[0].angle-=10000*Paddle[z].speedy/Paddle[z].topspeed-20000*tf;
						end
					end
				else
						Ball[0].noclip[z] = 0;
				end
			end

		/* Ball doesn't go to steep */
			if( (Ball[0].angle>70000 && Ball[0].angle<110000) || (Ball[0].angle>250000 && Ball[0].angle<290000) )
				Ball[0].angle = rand(0,360000);
			end

			Ball[0].speedx = cos(Ball[0].angle)*Ball[0].speed/10;
			Ball[0].speedy = -sin(Ball[0].angle)*Ball[0].speed/10;

	    	Ball[0].x+=Ball[0].speedx;
	    	Ball[0].y+=Ball[0].speedy;

		/* Ball wall bounce */
			if(Ball[0].y<0)
				Ball[0].angle = (-Ball[0].angle); //360!
				Ball[0].speed = Ball[0].speed*Ball[0].speedinc;
			end
			if(Ball[0].y>4300-Ball[0].h)
				Ball[0].angle = (-Ball[0].angle); //360!
				Ball[0].speed = Ball[0].speed*Ball[0].speedinc;
			end
		end // for

	/* Paddle control */
		Paddle[0].speedy=Paddle[0].topspeed*(key(_s)-key(_w));
		Paddle[1].speedy=Paddle[1].topspeed*(key(_down)-key(_up));

		Paddle[0].y+=Paddle[0].speedy;
		Paddle[1].y+=Paddle[1].speedy;

	/* Paddles stay within region */
		for(z=0; z<=1; z++)
			if(Paddle[z].y<0)
				Paddle[z].y = 0;
			end
			if(Paddle[z].y>4300-Paddle[z].h)
				Paddle[z].y = 4300-Paddle[z].h;
			end
		end

	/* Ball regenerate */
		if(key(_space) && !Ball[0].alive)
			Ball[0].alive = 1;
			Ball.speed = rand(200,300);
			Ball.angle = 180000*rand(0,1);
		end

	/* Ball shadow/trail */
		cnumber++;
		if(cnumber>9)
			cnumber=0;
		end
		BallS[cnumber].x = Ball[0].x;
		BallS[cnumber].y = Ball[0].y;
		BallS[cnumber].w = Ball[0].w/1.5;
		BallS[cnumber].h = Ball[0].h/1.5;
		
		if(fenixdisplay)
			put(0,LCDC.Device.map,10,10);
		end
		frame;
	END // while

	let_me_alone();

/* LCD DeInit */
	LCD_CLOSE(0);								// Close the connection to the device

	LCD_QUIT();								// Deinitialise LCD.DLL

END

/**********************************************************\
* [PON] Draw LCD screen                            Sandman *
*                                                          *
\**********************************************************/

PROCESS draw_lcd()

BEGIN

	priority = -1;

	loop
		map_clear(0,LCDC.Device.map,1);
		draw_paddle(0);
		draw_paddle(1);
		if(Ball[0].alive)
			draw_ball(0);
			for(z=0; z<10; z++)
				draw_ballshadow(z);
			end
		end
		draw_score();
		LCD_SetBitmap(0,LCDC.Device.pmap,LCD_PRIORITY_NORMAL);
		frame(100);
	end

END

/**********************************************************\
* [PON] Draw Paddle                                Sandman *
*                                                          *
\**********************************************************/

PROCESS draw_paddle(byte ident)

PRIVATE
	i;j;
	w;h;

BEGIN

	x = Paddle[ident].x;
	y = Paddle[ident].y;
	w = Paddle[ident].w;
	h = Paddle[ident].h;

	for(i=x; i<x+w; i+=100)
		for(j=y; j<y+h; j+=100)
			if(i>=0)
			if(i<=16000)
			if(j>=0)
			if(j<=4300)
				map_put_pixel(0,LCDC.Device.map,i/100,j/100,255);
			end end end end
		end
	end

END

/**********************************************************\
* [PON] Draw Ball                                  Sandman *
*                                                          *
\**********************************************************/

PROCESS draw_ball(byte ident)

PRIVATE
	i;j;
	w;h;

BEGIN

	x = Ball[ident].x;
	y = Ball[ident].y;
	w = Ball[ident].w;
	h = Ball[ident].h;

	for(i=x; i<x+w; i+=100)
		for(j=y; j<y+h; j+=100)
			if(i>=0)
			if(i<=16000)
			if(j>=0)
			if(j<=4300)
				map_put_pixel(0,LCDC.Device.map,i/100,j/100,255);
			end end end end
		end
	end

END

/**********************************************************\
* [PON] Draw Ball Shadow/Trail                     Sandman *
*                                                          *
\**********************************************************/

PROCESS draw_ballshadow(byte ident)

PRIVATE
	i;j;
	w;h;

BEGIN

	x = BallS[ident].x;
	y = BallS[ident].y;
	w = BallS[ident].w;
	h = BallS[ident].h;

	for(i=x; i<x+w; i+=100)
		for(j=y; j<y+h; j+=100)
			if(i>=0)
			if(i<=16000)
			if(j>=0)
			if(j<=4300)
				map_put_pixel(0,LCDC.Device.map,i/100,j/100,255);
			end end end end
		end
	end

END

/**********************************************************\
* [PON] Draw Score                                 Sandman *
*                                                          *
\**********************************************************/

PROCESS draw_score()

BEGIN
	set_text_color(255);
//	write_on_map(0,LCDC.Device.map,75,1,0,Paddle[0].score,2);
//	write_on_map(0,LCDC.Device.map,85,1,0,Paddle[1].score,0);
	x = write_in_map(0,Paddle[0].score,2);
	map_put(0,LCDC.Device.map,x,75,1);
	unload_map(0,x);
	x = write_in_map(0,Paddle[1].score,0);
	map_put(0,LCDC.Device.map,x,85,1);
	unload_map(0,x);
END

/**********************************************************\
* [PON] Check ball collision with Paddle           Sandman *
*                                                          *
\**********************************************************/

PROCESS Ball_col( i );

BEGIN

		if(Ball[0].x =< Paddle[i].x + Paddle[i].w)
		if(Ball[0].x + Ball[0].w >= Paddle[i].x)
		if(Ball[0].y =< Paddle[i].y + Paddle[i].h)
		if(Ball[0].y + Ball[0].h >= Paddle[i].y)
			return 1;
		end end end end

		return 0;

END